! Dean Townsley 2010

subroutine Simulation_init()
  
  use Simulation_data
  use Grid_interface, ONLY : Grid_getGlobalIndexLimits, &
    Grid_getMinCellSize
  use hse_interface, ONLY: sim_hse_step, envelope_hse
  use RuntimeParameters_interface, ONLY : RuntimeParameters_get
  implicit none
#include "Flash.h"
#include "constants.h"
#include "Eos.h"

  integer, dimension(MDIM) :: globalIndexLimits
  integer  :: nx
  real     :: deltax

!===========================================================================

  call RuntimeParameters_get("gconst",sim_grav)

  call RuntimeParameters_get("temp_cz_base", sim_temp_cz_base)
  call RuntimeParameters_get("dens_he_base", sim_dens_he_base)
  call RuntimeParameters_get("temp_under", sim_temp_under)
  call RuntimeParameters_get("y_he_under_cz", sim_y_he_under_cz)
  call RuntimeParameters_get("x_c12_cz", sim_x_c12_cz)
  call RuntimeParameters_get("x_o16_cz", sim_x_o16_cz)
  call RuntimeParameters_get("x_c12_under", sim_x_c12_under)
  call RuntimeParameters_get("x_o16_under", sim_x_o16_under)

  call RuntimeParameters_get("ign_x", sim_ign_x)
  call RuntimeParameters_get("ign_z", sim_ign_y)
  call RuntimeParameters_get("ign_r", sim_ign_r)
  call RuntimeParameters_get("ign_temp_center", sim_ign_temp_center)
  call RuntimeParameters_get("ign_temp_edge", sim_ign_temp_edge)

  call RuntimeParameters_get("shk_pos_band_bot", sim_shk_pos_band_bot)
  call RuntimeParameters_get("shk_pos_band_top", sim_shk_pos_band_top)
  call RuntimeParameters_get("shk_pos_temp_thresh", sim_shk_pos_temp_thresh)

  call RuntimeParameters_get('refFluffDensThresh', sim_refFluffDensThresh)
  call RuntimeParameters_get('refFluffMargin', sim_refFluffMargin)
  call RuntimeParameters_get('refFluffLevel', sim_refFluffLevel)

  call RuntimeParameters_get('refNogenEnucThresh', sim_refNogenEnucThresh)
  call RuntimeParameters_get('refNogenMargin', sim_refNogenMargin)
  call RuntimeParameters_get('refNogenLevel', sim_refNogenLevel)

  sim_refShellHe4Abund = 1.0 - sim_x_c12_under - sim_x_o16_under
  sim_refCoreMg24Abund = 1.0


  ! measure domain and dimension array to hold initial profile
  call Grid_getGlobalIndexLimits(globalIndexLimits)
  ! assume the cells are square for now
  call Grid_getMinCellSize(deltax)

  nx = globalIndexLimits(IAXIS)
  allocate(sim_dens_i(nx))
  allocate(sim_temp_i(nx))
  allocate(sim_he_i(nx))

  ! set flame profile
  call RuntimeParameters_get("he_base_position", sim_x0)

  call envelope_hse(sim_dens_i, sim_temp_i, sim_he_i, sim_cz_base_position, &
                 sim_dens_he_base, sim_temp_cz_base, sim_temp_under, sim_y_he_under_cz, &
                 sim_x_c12_cz, sim_x_o16_cz, sim_x_c12_under, sim_x_o16_under, sim_x0, 0.5*deltax, deltax, sim_grav, nx)

end subroutine Simulation_init

