! Dean Townsley 2008

Module hse_interface

interface
subroutine sim_hse_step(dens, temp, ye, sumy, n, inputg, delta, direction, order, mode)
  implicit none
  real, dimension(:), intent(IN)    :: ye, sumy
  real, dimension(:), intent(INOUT) :: dens, temp
  integer, intent(IN)               :: n               ! index to update
  real, intent(IN)                  :: inputg, delta
  integer, intent(IN)               :: direction, order, mode
end subroutine sim_hse_step
end interface

! initialize helium layers on carbon with base at bposition in HSE
!     dens_he_c is the density at the He-C layer interface (base of accreted layer)
interface
subroutine envelope_hse(dens, temp, he, cz_base_position, &
                     dens_he_c, temp_base_cz, temp_under, y_he_under_cz, &
                     x_c12_cz, x_o16_cz, x_c12_under, x_o16_under, bposition, x1, dx, grav, nfill)
  implicit none
  real, dimension(:), intent(OUT)  :: dens, temp, he
  real, intent(OUT)                :: cz_base_position
  real, intent(IN)                 :: dens_he_c, temp_base_cz, temp_under, y_he_under_cz
  real, intent(IN)                 :: x_c12_cz, x_o16_cz, x_c12_under, x_o16_under, bposition, x1, dx, grav
  integer, intent(IN)              :: nfill
  ! x0 is coordinate of first element in return arrays, dx is spacing and nfill
  ! is the number of cells that this function should fill
  ! also an isothermal helium layer of extent y_he_under_cz is placed under the convection zone
end subroutine envelope_hse
end interface

end Module hse_interface
